<script setup lang="ts">
  import { Switch, SwitchGroup, SwitchLabel } from '@headlessui/vue';

  const slots = useSlots();

  const props = defineProps<{
    modelValue?: boolean;
  }>();

  const emit = defineEmits(['update:modelValue']);

  const enabled = computed({
    get: () => {
      return props.modelValue;
    },
    set: (newValue) => {
      emit('update:modelValue', newValue);
    },
  });
</script>

<template>
  <SwitchGroup>
    <div class="flex items-center">
      <Switch
        v-model="enabled"
        :class="[
          enabled
            ? 'border-emerald-900 bg-emerald-500 hover:bg-emerald-700 active:bg-emerald-800 disabled:border-emerald-300 disabled:bg-emerald-100 disabled:hover:bg-emerald-100 disabled:active:bg-emerald-100'
            : 'bg-interactive border-border hover:bg-interactive-hover active:bg-interactive-pressed hover:bg-interactive-hover active:bg-interactive-pressed disabled:bg-background-raised disabled:active:bg-background-raised',
          'group relative inline-flex h-5 w-8 flex-shrink-0 cursor-pointer rounded-full border transition-colors duration-200 ease-in-out',
          'disabled:cursor-not-allowed disabled:shadow-none',
        ]"
        v-bind="$attrs"
      >
        <span
          :class="[
            enabled
              ? 'translate-x-3.125 border-emerald-900 group-disabled:border-emerald-300'
              : 'translate-x-0.375 border-border',
            'pointer-events-none relative top-1/2 inline-block h-4 w-4 -translate-y-1/2 transform rounded-full border bg-white shadow ring-0 transition duration-200 ease-in-out',
          ]"
        >
          <span
            :class="[
              enabled ? 'opacity-0 duration-100 ease-out' : 'opacity-100 duration-200 ease-in',
              'absolute inset-0 flex h-full w-full items-center justify-center transition-opacity',
            ]"
            aria-hidden="true"
          >
            <svg
              class="text-information group-disabled:text-border h-3 w-3"
              fill="none"
              viewBox="0 0 12 12"
            >
              <path
                d="M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2"
                stroke="currentColor"
                stroke-width="2"
                stroke-linecap="round"
                stroke-linejoin="round"
              />
            </svg>
          </span>
          <span
            :class="[
              enabled ? 'opacity-100 duration-200 ease-in ' : 'opacity-0 duration-100 ease-out',
              'absolute inset-0 flex h-full w-full items-center justify-center transition-opacity',
            ]"
            aria-hidden="true"
          >
            <svg
              class="h-3 w-3 text-emerald-700 group-disabled:text-emerald-300"
              fill="currentColor"
              viewBox="0 0 12 12"
            >
              <path
                d="M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z"
              />
            </svg>
          </span>
        </span>
      </Switch>
      <SwLabel v-if="slots.label" :as="SwitchLabel" class="pl-2">
        <slot name="label"></slot>
      </SwLabel>
    </div>
  </SwitchGroup>
</template>
